/******************************************************************************
** Copyright (c) 2014 Intel Corporation All Rights Reserved
**
** Licensed under the Apache License, Version 2.0 (the "License"); you may not
** use this file except in compliance with the License.
**
** You may obtain a copy of the License at
**     http://www.apache.org/licenses/LICENSE-2.0
**
** Unless required by applicable law or agreed to in writing, software
** distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
** WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
**
** See the License for the specific language governing permissions and
** limitations under the License.
**
******************************************************************************/

#ifndef _ESIF_PRIMITIVE_TYPE_H_
#define _ESIF_PRIMITIVE_TYPE_H_

#include "esif.h"

/*
** PRIMITIVE Declarations
*/

#define ENUM_ESIF_PRIMITIVE_TYPE(ENUM) \
    ENUM##_VAL(GET_ACTIVE_RELATIONSHIP_TABLE, 89) \
    ENUM##_VAL(GET_AMBIENT_CAPICITANCE_COEF, 243) \
    ENUM##_VAL(GET_AMBIENT_NOTIFICATION_THRESHOLD, 244) \
    ENUM##_VAL(GET_BATTERY_INFORMATION, 224) \
    ENUM##_VAL(GET_BATTERY_STATUS, 223) \
    ENUM##_VAL(GET_CLOCK_COUNT, 185) \
    ENUM##_VAL(GET_CLOCK_ORIGINAL_FREQUENCY, 187) \
    ENUM##_VAL(GET_CURRENT_LOW_POWER_MODE, 94) \
    ENUM##_VAL(GET_DEVICE_ADDRESS_ON_PARENT_BUS, 49) \
    ENUM##_VAL(GET_DEVICE_COMPATABILITY_ID, 50) \
    ENUM##_VAL(GET_DEVICE_DESCRIPTION, 60) \
    ENUM##_VAL(GET_DEVICE_HARDWARE_ID, 53) \
    ENUM##_VAL(GET_DEVICE_STATUS, 88) \
    ENUM##_VAL(GET_DEVICE_UNIQUE_ID, 67) \
    ENUM##_VAL(GET_DISPLAY_BRIGHTNESS_LEVELS, 158) \
    ENUM##_VAL(GET_DISPLAY_BRIGHTNESS_SOFT, 157) \
    ENUM##_VAL(GET_DISPLAY_CAPABILITY, 159) \
    ENUM##_VAL(GET_DISPLAY_CLOCK_DEVIATION, 181) \
    ENUM##_VAL(GET_DISPLAY_CLOCK_DOWNWARD_DEVIATION, 250) \
    ENUM##_VAL(GET_DISPLAY_CLOCK_UPWARD_DEVIATION, 249) \
    ENUM##_VAL(GET_DISPLAY_CLOCK_SPREAD_DIRECTION, 191) \
    ENUM##_VAL(GET_DISPLAY_CLOCK_SPREAD_PERCENTAGE, 190) \
    ENUM##_VAL(GET_DISPLAY_CLOCK_SSC_DISABLED_FREQUENCY, 189) \
    ENUM##_VAL(GET_DISPLAY_CLOCK_SSC_ENABLED_FREQUENCY, 188) \
    ENUM##_VAL(GET_DISPLAY_DEPTH_LIMIT, 160) \
    ENUM##_VAL(GET_DISPLAY_PANEL_TYPE, 179) \
    ENUM##_VAL(GET_DOMAIN_PRIORITY, 178) \
    ENUM##_VAL(GET_FAN_INFORMATION, 84) \
    ENUM##_VAL(GET_FAN_PERFORMANCE_STATES, 85) \
    ENUM##_VAL(GET_FAN_STATUS, 86) \
    ENUM##_VAL(GET_GRAPHICS_CHIPSET_CHANNEL_TYPE, 182) \
    ENUM##_VAL(GET_GRAPHICS_CHIPSET_SSC_ENABLED, 184) \
    ENUM##_VAL(GET_LPM_TABLE, 237) \
    ENUM##_VAL(GET_NOTIFICATION_TEMP_THRESHOLD, 54) \
    ENUM##_VAL(GET_PARTICIPANT_LIST, 90) \
    ENUM##_VAL(GET_PARTICIPANT_PERF_PRESENT_CAPABILITY, 176) \
    ENUM##_VAL(GET_PARTICIPANT_SKU, 141) \
    ENUM##_VAL(GET_PARTICIPANT_TYPE, 139) \
    ENUM##_VAL(GET_PARTICIPANT_UTILIZATION, 138) \
    ENUM##_VAL(GET_PERF_PSTATE_DEPTH_LIMIT, 76) \
    ENUM##_VAL(GET_PERF_SUPPORT_STATES, 137) \
    ENUM##_VAL(GET_POWER_THRESHOLD_COUNT, 196) \
    ENUM##_VAL(GET_POWER_THRESHOLD_HYSTERESIS, 197) \
    ENUM##_VAL(GET_POWER_THRESHOLDS, 198) \
    ENUM##_VAL(GET_PROC_APPLICATION_EXCLUDE_LIST, 68) \
    ENUM##_VAL(GET_PROC_CTDP_CAPABILITY, 79) \
    ENUM##_VAL(GET_PROC_CTDP_CURRENT_SETTING, 26) \
    ENUM##_VAL(GET_PROC_CTDP_LOCK_STATUS, 27) \
    ENUM##_VAL(GET_PROC_CTDP_POINT_LIST, 80) \
    ENUM##_VAL(GET_PROC_CTDP_SUPPORT_CHECK, 25) \
    ENUM##_VAL(GET_PROC_CTDP_TAR_LOCK_STATUS, 28) \
    ENUM##_VAL(GET_PROC_CURRENT_LOGICAL_PROCESSOR_OFFLINING, 69) \
    ENUM##_VAL(GET_PROC_IO_THROTTLE_STATUS, 151) \
    ENUM##_VAL(GET_PROC_LOGICAL_PROCESSOR_AFFINITY, 228) \
    ENUM##_VAL(GET_PROC_LOGICAL_PROCESSOR_COUNT, 101) \
    ENUM##_VAL(GET_PROC_MFM_LPM_SUPPORTED, 207) \
    ENUM##_VAL(GET_PROC_MFM_MAX_EFFICIENCY_RATIO, 209) \
    ENUM##_VAL(GET_PROC_MFM_MIN_SUPPORTED_RATIO, 208) \
    ENUM##_VAL(GET_PROC_PERF_MAX_TIME, 103) \
    ENUM##_VAL(GET_PROC_PERF_PRESENT_CAPABILITY, 56) \
    ENUM##_VAL(GET_PROC_PERF_PSTATE_CURRENT_MAX_TODO, 99) \
    ENUM##_VAL(GET_PROC_PERF_PSTATE_DEPTH_LIMIT, 55) \
    ENUM##_VAL(GET_PROC_PERF_PSTATE_STATUS_TODO, 98) \
    ENUM##_VAL(GET_PROC_PERF_SUPPORT_STATES, 95) \
    ENUM##_VAL(GET_PROC_PERF_THROTTLE_CONTROL, 58) \
    ENUM##_VAL(GET_PROC_PERF_THROTTLE_PRESENT_CAPABILITY, 62) \
    ENUM##_VAL(GET_PROC_PERF_TSTATE_DEPTH_LIMIT, 61) \
    ENUM##_VAL(GET_PROC_THERMAL_DESIGN_POWER, 21) \
    ENUM##_VAL(GET_PROC_TJMAX, 20) \
    ENUM##_VAL(GET_PROC_TURBO_ACTIVATION_RATIO, 219) \
    ENUM##_VAL(GET_PROC_PROGRAMMABLE_POWER_LIMITS, 97) \
    ENUM##_VAL(GET_PROC_TURBO_STATE, 218) \
    ENUM##_VAL(GET_RAPL_DUTY_CYCLE, 149) \
    ENUM##_VAL(GET_RAPL_ENERGY, 128) \
    ENUM##_VAL(GET_RAPL_ENERGY_UNIT, 123) \
    ENUM##_VAL(GET_RAPL_POWER, 35) \
    ENUM##_VAL(GET_RAPL_POWER_CONTROL_CAPABILITIES, 75) \
    ENUM##_VAL(GET_RAPL_POWER_DEFAULT, 148) \
    ENUM##_VAL(GET_RAPL_POWER_LIMIT, 38) \
    ENUM##_VAL(GET_RAPL_POWER_LIMIT_ENABLE, 126) \
    ENUM##_VAL(GET_RAPL_POWER_LIMIT_LOCK, 172) \
    ENUM##_VAL(GET_RAPL_POWER_MAX, 23) \
    ENUM##_VAL(GET_RAPL_POWER_MAX_TIME_WINDOW, 24) \
    ENUM##_VAL(GET_RAPL_POWER_MIN, 22) \
    ENUM##_VAL(GET_RAPL_POWER_UNIT, 124) \
    ENUM##_VAL(GET_RAPL_TIME_UNIT, 122) \
    ENUM##_VAL(GET_RAPL_TIME_WINDOW, 39) \
    ENUM##_VAL(GET_RFPROFILE_BIT_ERROR, 265) \
    ENUM##_VAL(GET_RFPROFILE_CENTER_FREQUENCY, 245) \
    ENUM##_VAL(GET_RFPROFILE_CHANNEL_NUMBER, 260) \
    ENUM##_VAL(GET_RFPROFILE_CLIP_PERCENT_LEFT, 255) \
    ENUM##_VAL(GET_RFPROFILE_CLIP_PERCENT_RIGHT, 256) \
    ENUM##_VAL(GET_RFPROFILE_CONNECTION_STATUS, 264) \
    ENUM##_VAL(GET_RFPROFILE_DEFAULT_CENTER_FREQUENCY, 254) \
    ENUM##_VAL(GET_RFPROFILE_FREQUENCY_ADJUST_RESOLUTION, 257) \
    ENUM##_VAL(GET_RFPROFILE_FREQUENCY_SPREAD_LEFT, 246) \
    ENUM##_VAL(GET_RFPROFILE_FREQUENCY_SPREAD_RIGHT, 251) \
    ENUM##_VAL(GET_RFPROFILE_NOISE_POWER, 261) \
    ENUM##_VAL(GET_RFPROFILE_NOTCH_LEFT, 258) \
    ENUM##_VAL(GET_RFPROFILE_NOTCH_RIGHT, 259) \
    ENUM##_VAL(GET_RFPROFILE_RSSI, 263) \
    ENUM##_VAL(GET_RFPROFILE_SHAPE_LEFT, 247) \
    ENUM##_VAL(GET_RFPROFILE_SHAPE_RIGHT, 253) \
    ENUM##_VAL(GET_RFPROFILE_SIGNAL_TO_NOISE_RATIO, 262) \
    ENUM##_VAL(GET_SUPPORTED_POLICIES, 92) \
    ENUM##_VAL(GET_TEMPERATURE, 14) \
    ENUM##_VAL(GET_TEMPERATURE_APPROX_TABLE, 164) \
    ENUM##_VAL(GET_TEMPERATURE_THRESHOLD_COUNT, 72) \
    ENUM##_VAL(GET_TEMPERATURE_THRESHOLD_HYSTERESIS, 15) \
    ENUM##_VAL(GET_TEMPERATURE_THRESHOLDS, 143) \
    ENUM##_VAL(GET_THERMAL_RELATIONSHIP_TABLE, 91) \
    ENUM##_VAL(GET_TRIP_POINT_ACTIVE, 1) \
    ENUM##_VAL(GET_TRIP_POINT_CRITICAL, 13) \
    ENUM##_VAL(GET_TRIP_POINT_HOT, 12) \
    ENUM##_VAL(GET_TRIP_POINT_PASSIVE, 11) \
    ENUM##_VAL(GET_TRIP_POINT_WARM, 177) \
    ENUM##_VAL(GET_TSTATE_CURRENT, 16) \
    ENUM##_VAL(GET_TSTATES, 65) \
    ENUM##_VAL(SET_ACTIVE_CORE_LIMIT, 153) \
    ENUM##_VAL(SET_ACTIVE_RELATIONSHIP_TABLE, 230) \
    ENUM##_VAL(SET_AMBIENT_TEMPERATURE_INDICATION, 242) \
    ENUM##_VAL(SET_CLOCK_SSC_DISABLED, 194) \
    ENUM##_VAL(SET_CLOCK_SSC_ENABLED, 193) \
    ENUM##_VAL(SET_COOLING_POLICY, 81) \
    ENUM##_VAL(SET_CTDP_POINT, 83) \
    ENUM##_VAL(SET_CURRENT_LOW_POWER_MODE, 236) \
    ENUM##_VAL(SET_DEVICE_TEMPERATURE_INDICATION, 51) \
    ENUM##_VAL(SET_DISPLAY_BRIGHTNESS_HARD, 226) \
    ENUM##_VAL(SET_DISPLAY_BRIGHTNESS_SOFT, 163) \
    ENUM##_VAL(SET_DSP, 200) \
    ENUM##_VAL(SET_FAN_LEVEL, 87) \
    ENUM##_VAL(SET_LPM_TABLE, 238) \
    ENUM##_VAL(SET_OPERATING_SYSTEM_CAPABILITIES, 93) \
    ENUM##_VAL(SET_PERF_PRESENT_CAPABILITY, 82) \
    ENUM##_VAL(SET_PERF_SUPPORT_STATE, 227) \
    ENUM##_VAL(SET_POWER_THRESHOLD_HYSTERESIS, 233) \
    ENUM##_VAL(SET_POWER_THRESHOLDS, 199) \
    ENUM##_VAL(SET_PROC_CTDP_CONTROL, 221) \
    ENUM##_VAL(SET_RFPROFILE_CENTER_FREQUENCY, 211) \
    ENUM##_VAL(SET_PROC_IO_THROTTLE_CONTROL, 152) \
    ENUM##_VAL(SET_PROC_LOGICAL_PROCESSOR_AFFINITY, 229) \
    ENUM##_VAL(SET_PROC_TURBO_ACTIVATION_RATIO, 220) \
    ENUM##_VAL(SET_PROC_TURBO_STATE, 100) \
    ENUM##_VAL(SET_RAPL_POWER_LIMIT, 130) \
    ENUM##_VAL(SET_RAPL_POWER_LIMIT_ENABLE, 222) \
    ENUM##_VAL(SET_RAPL_TIME_WINDOW, 127) \
    ENUM##_VAL(SET_SYSTEM_HIBERNATE, 175) \
    ENUM##_VAL(SET_SYSTEM_SHUTDOWN, 173) \
    ENUM##_VAL(SET_SYSTEM_SLEEP, 174) \
    ENUM##_VAL(SET_TEMPERATURE, 241) \
    ENUM##_VAL(SET_TEMPERATURE_THRESHOLD_HYSTERESIS, 232) \
    ENUM##_VAL(SET_TEMPERATURE_THRESHOLDS, 47) \
    ENUM##_VAL(SET_THERMAL_RELATIONSHIP_TABLE, 231) \
    ENUM##_VAL(SET_TRIP_POINT_ACTIVE, 202) \
    ENUM##_VAL(SET_TRIP_POINT_CRITICAL, 203) \
    ENUM##_VAL(SET_TRIP_POINT_HOT, 204) \
    ENUM##_VAL(SET_TRIP_POINT_PASSIVE, 206) \
    ENUM##_VAL(SET_TRIP_POINT_WARM, 205) \
    ENUM##_VAL(SET_TSTATE_CURRENT, 147) \

enum esif_primitive_type {
#ifdef ESIF_ATTR_KERNEL
    GET_ACTIVE_RELATIONSHIP_TABLE                   = 89,
    GET_AMBIENT_CAPICITANCE_COEF                    = 243,
    GET_AMBIENT_NOTIFICATION_THRESHOLD              = 244,
    GET_BATTERY_INFORMATION                         = 224,
    GET_BATTERY_STATUS                              = 223,
    GET_CLOCK_COUNT                                 = 185,
    GET_CLOCK_ORIGINAL_FREQUENCY                    = 187,
    GET_DEVICE_ADDRESS_ON_PARENT_BUS                = 49,
    GET_DEVICE_COMPATABILITY_ID                     = 50,
    GET_DEVICE_DESCRIPTION                          = 60,
    GET_DEVICE_HARDWARE_ID                           = 53,
    GET_DEVICE_STATUS                               = 88,
    GET_DEVICE_UNIQUE_ID                            = 67,
    GET_DISPLAY_BRIGHTNESS_LEVELS                    = 158,
    GET_DISPLAY_BRIGHTNESS_SOFT                     = 157,
    GET_DISPLAY_CAPABILITY                          = 159,
    GET_DISPLAY_CLOCK_DEVIATION                     = 181,
    GET_DISPLAY_CLOCK_DOWNWARD_DEVIATION            = 250,
    GET_DISPLAY_CLOCK_UPWARD_DEVIATION              = 249,
    GET_DISPLAY_CLOCK_SPREAD_DIRECTION              = 191,
    GET_DISPLAY_CLOCK_SPREAD_PERCENTAGE             = 190,
    GET_DISPLAY_CLOCK_SSC_DISABLED_FREQUENCY        = 189,
    GET_DISPLAY_CLOCK_SSC_ENABLED_FREQUENCY         = 188,
    GET_DISPLAY_DEPTH_LIMIT                         = 160,
    GET_DISPLAY_PANEL_TYPE                          = 179,
    GET_DOMAIN_PRIORITY                             = 178,
    GET_FAN_INFORMATION                             = 84,
    GET_FAN_PERFORMANCE_STATES                      = 85,
    GET_FAN_STATUS                                  = 86,
    GET_GRAPHICS_CHIPSET_CHANNEL_TYPE               = 182,
    GET_GRAPHICS_CHIPSET_SSC_ENABLED                = 184,
    GET_LPM_TABLE                                   = 237,
    GET_NOTIFICATION_TEMP_THRESHOLD                 = 54,
    GET_PARTICIPANT_LIST                            = 90,
    GET_PARTICIPANT_PERF_PRESENT_CAPABILITY         = 176,
    GET_PARTICIPANT_SKU                             = 141,
    GET_PARTICIPANT_TYPE                            = 139,
    GET_PARTICIPANT_UTILIZATION                     = 138,
    GET_PERF_PSTATE_DEPTH_LIMIT                     = 76,
    GET_PERF_SUPPORT_STATES                         = 137,
    GET_POWER_THRESHOLD_COUNT                       = 196,
    GET_POWER_THRESHOLD_HYSTERESIS                  = 197,
    GET_POWER_THRESHOLDS                            = 198,
    GET_PROC_APPLICATION_EXCLUDE_LIST               = 68,
    GET_PROC_CTDP_CAPABILITY                        = 79,
    GET_PROC_CTDP_CURRENT_SETTING                   = 26,
    GET_PROC_CTDP_LOCK_STATUS                       = 27,
    GET_PROC_CTDP_POINT_LIST                        = 80,
    GET_PROC_CTDP_SUPPORT_CHECK                     = 25,
    GET_PROC_CTDP_TAR_LOCK_STATUS                   = 28,
    GET_PROC_CURRENT_LOGICAL_PROCESSOR_OFFLINING    = 69,
    GET_CURRENT_LOW_POWER_MODE                      = 94,
    GET_PROC_IO_THROTTLE_STATUS                     = 151,
    GET_PROC_LOGICAL_PROCESSOR_AFFINITY             = 228,
    GET_PROC_LOGICAL_PROCESSOR_COUNT                = 101,
    GET_PROC_MFM_LPM_SUPPORTED                      = 207,
    GET_PROC_MFM_MAX_EFFICIENCY_RATIO               = 209,
    GET_PROC_MFM_MIN_SUPPORTED_RATIO                = 208,
    GET_PROC_PERF_MAX_TIME                          = 103,
    GET_PROC_PERF_PRESENT_CAPABILITY                = 56,
    GET_PROC_PERF_PSTATE_CURRENT_MAX_TODO           = 99,
    GET_PROC_PERF_PSTATE_DEPTH_LIMIT                = 55,
    GET_PROC_PERF_PSTATE_STATUS_TODO                = 98,
    GET_PROC_PERF_SUPPORT_STATES                    = 95,
    GET_PROC_PERF_THROTTLE_CONTROL                  = 58,
    GET_PROC_PERF_THROTTLE_PRESENT_CAPABILITY       = 62,
    GET_PROC_PERF_TSTATE_DEPTH_LIMIT                = 61,
    GET_PROC_THERMAL_DESIGN_POWER                   = 21,
    GET_PROC_TJMAX                                  = 20,
    GET_PROC_TURBO_ACTIVATION_RATIO                 = 219,
    GET_PROC_PROGRAMMABLE_POWER_LIMITS              = 97,
    GET_PROC_TURBO_STATE                            = 218,
    GET_RAPL_DUTY_CYCLE                             = 149,
    GET_RAPL_ENERGY                                 = 128,
    GET_RAPL_ENERGY_UNIT                            = 123,
    GET_RAPL_POWER                                  = 35,
    GET_RAPL_POWER_CONTROL_CAPABILITIES             = 75,
    GET_RAPL_POWER_DEFAULT                          = 148,
    GET_RAPL_POWER_LIMIT                            = 38,
    GET_RAPL_POWER_LIMIT_ENABLE                     = 126,
    GET_RAPL_POWER_LIMIT_LOCK                       = 172,
    GET_RAPL_POWER_MAX                              = 23,
    GET_RAPL_POWER_MAX_TIME_WINDOW                  = 24,
    GET_RAPL_POWER_MIN                              = 22,
    GET_RAPL_POWER_UNIT                             = 124,
    GET_RAPL_TIME_UNIT                              = 122,
    GET_RAPL_TIME_WINDOW                            = 39,
    GET_RFPROFILE_BIT_ERROR                         = 265,
    GET_RFPROFILE_CENTER_FREQUENCY                  = 245,
    GET_RFPROFILE_CHANNEL_NUMBER                    = 260,
    GET_RFPROFILE_CLIP_PERCENT_LEFT                 = 255,
    GET_RFPROFILE_CLIP_PERCENT_RIGHT                = 256,
    GET_RFPROFILE_CONNECTION_STATUS                 = 264,
    GET_RFPROFILE_DEFAULT_CENTER_FREQUENCY          = 254,
    GET_RFPROFILE_FREQUENCY_ADJUST_RESOLUTION       = 257,
    GET_RFPROFILE_FREQUENCY_SPREAD_LEFT             = 246,
    GET_RFPROFILE_FREQUENCY_SPREAD_RIGHT            = 251,
    GET_RFPROFILE_NOISE_POWER                       = 261,
    GET_RFPROFILE_NOTCH_LEFT                        = 258,
    GET_RFPROFILE_NOTCH_RIGHT                       = 259,
    GET_RFPROFILE_RSSI                              = 263,
    GET_RFPROFILE_SHAPE_LEFT                        = 247,
    GET_RFPROFILE_SHAPE_RIGHT                       = 253,
    GET_RFPROFILE_SIGNAL_TO_NOISE_RATIO             = 262,
    GET_SUPPORTED_POLICIES                          = 92,
    GET_TEMPERATURE                                 = 14,
    GET_TEMPERATURE_APPROX_TABLE                    = 164,
    GET_TEMPERATURE_THRESHOLD_COUNT                 = 72,
    GET_TEMPERATURE_THRESHOLD_HYSTERESIS            = 15,
    GET_TEMPERATURE_THRESHOLDS                      = 143,
    GET_THERMAL_RELATIONSHIP_TABLE                  = 91,
    GET_TRIP_POINT_ACTIVE                           = 1,
    GET_TRIP_POINT_CRITICAL                         = 13,
    GET_TRIP_POINT_HOT                              = 12,
    GET_TRIP_POINT_PASSIVE                          = 11,
    GET_TRIP_POINT_WARM                             = 177,
    GET_TSTATE_CURRENT                              = 16,
    GET_TSTATES                                     = 65,
    SET_ACTIVE_CORE_LIMIT                           = 153,
    SET_ACTIVE_RELATIONSHIP_TABLE                   = 230,
    SET_AMBIENT_TEMPERATURE_INDICATION              = 242,
    SET_CLOCK_SSC_DISABLED                          = 194,
    SET_CLOCK_SSC_ENABLED                           = 193,
    SET_COOLING_POLICY                              = 81,
    SET_CTDP_POINT                                  = 83,
    SET_CURRENT_LOW_POWER_MODE                      = 236,
    SET_DEVICE_TEMPERATURE_INDICATION               = 51,
    SET_DISPLAY_BRIGHTNESS_HARD                     = 226,
    SET_DISPLAY_BRIGHTNESS_SOFT                     = 163,
    SET_DSP                                         = 200,
    SET_FAN_LEVEL                                   = 87,
    SET_LPM_TABLE                                   = 238,
    SET_OPERATING_SYSTEM_CAPABILITIES               = 93,
    SET_PERF_PRESENT_CAPABILITY                     = 82,
    SET_PERF_SUPPORT_STATE                          = 227,
    SET_POWER_THRESHOLD_HYSTERESIS                  = 233,
    SET_POWER_THRESHOLDS                            = 199,
    SET_PROC_CTDP_CONTROL                           = 221,
    SET_RFPROFILE_CENTER_FREQUENCY                  = 211,
    SET_PROC_IO_THROTTLE_CONTROL                    = 152,
    SET_PROC_LOGICAL_PROCESSOR_AFFINITY             = 229,
    SET_PROC_TURBO_ACTIVATION_RATIO                 = 220,
    SET_PROC_TURBO_STATE                            = 100,
    SET_RAPL_POWER_LIMIT                            = 130,
    SET_RAPL_POWER_LIMIT_ENABLE                     = 222,
    SET_RAPL_TIME_WINDOW                            = 127,
    SET_SYSTEM_HIBERNATE                            = 175,
    SET_SYSTEM_SHUTDOWN                             = 173,
    SET_SYSTEM_SLEEP                                = 174,
    SET_TEMPERATURE                                 = 241,
    SET_TEMPERATURE_THRESHOLD_HYSTERESIS            = 232,
    SET_TEMPERATURE_THRESHOLDS                      = 47,
    SET_THERMAL_RELATIONSHIP_TABLE                  = 231,
    SET_TRIP_POINT_ACTIVE                           = 202,
    SET_TRIP_POINT_CRITICAL                         = 203,
    SET_TRIP_POINT_HOT                              = 204,
    SET_TRIP_POINT_PASSIVE                          = 206,
    SET_TRIP_POINT_WARM                             = 205,
    SET_TSTATE_CURRENT                              = 147,
#else
    ENUM_ESIF_PRIMITIVE_TYPE(ENUMDECL)
#endif
};

/* Implement these if they are needed */
extern enum esif_primitive_type esif_primitive_type_string2enum(esif_string str);
extern esif_string esif_primitive_type_enum2string(enum esif_primitive_type type);

static ESIF_INLINE esif_string esif_primitive_str(enum esif_primitive_type type)
{

#define CREATE_PRIMITIVE_TYPE(pt) case pt: \
    str = (esif_string) #pt;break;

#define CREATE_PRIMITIVE_TYPE_VAL(pt, VAL) case pt: \
    str = (esif_string) #pt;break;

    esif_string str = (esif_string)ESIF_NOT_AVAILABLE;
    switch (type) {

#ifdef ESIF_ATTR_KERNEL
    CREATE_PRIMITIVE_TYPE(GET_ACTIVE_RELATIONSHIP_TABLE)
    CREATE_PRIMITIVE_TYPE(GET_AMBIENT_CAPICITANCE_COEF)
    CREATE_PRIMITIVE_TYPE(GET_AMBIENT_NOTIFICATION_THRESHOLD)
    CREATE_PRIMITIVE_TYPE(GET_BATTERY_INFORMATION)
    CREATE_PRIMITIVE_TYPE(GET_BATTERY_STATUS)
    CREATE_PRIMITIVE_TYPE(GET_CLOCK_COUNT)
    CREATE_PRIMITIVE_TYPE(GET_CLOCK_ORIGINAL_FREQUENCY)
    CREATE_PRIMITIVE_TYPE(GET_DISPLAY_CLOCK_SPREAD_DIRECTION)
    CREATE_PRIMITIVE_TYPE(GET_DISPLAY_CLOCK_SPREAD_PERCENTAGE)
    CREATE_PRIMITIVE_TYPE(GET_DISPLAY_CLOCK_SSC_DISABLED_FREQUENCY)
    CREATE_PRIMITIVE_TYPE(GET_DISPLAY_CLOCK_SSC_ENABLED_FREQUENCY)
    CREATE_PRIMITIVE_TYPE(GET_DEVICE_ADDRESS_ON_PARENT_BUS)
    CREATE_PRIMITIVE_TYPE(GET_DEVICE_COMPATABILITY_ID)
    CREATE_PRIMITIVE_TYPE(GET_DEVICE_DESCRIPTION)
    CREATE_PRIMITIVE_TYPE(GET_DEVICE_HARDWARE_ID)
    CREATE_PRIMITIVE_TYPE(GET_DEVICE_STATUS)
    CREATE_PRIMITIVE_TYPE(GET_DEVICE_UNIQUE_ID)
    CREATE_PRIMITIVE_TYPE(GET_DISPLAY_BRIGHTNESS_LEVELS)
    CREATE_PRIMITIVE_TYPE(GET_DISPLAY_BRIGHTNESS_SOFT)
    CREATE_PRIMITIVE_TYPE(GET_DISPLAY_CAPABILITY)
    CREATE_PRIMITIVE_TYPE(GET_DISPLAY_CLOCK_DEVIATION)
    CREATE_PRIMITIVE_TYPE(GET_DISPLAY_CLOCK_DOWNWARD_DEVIATION)
    CREATE_PRIMITIVE_TYPE(GET_DISPLAY_CLOCK_UPWARD_DEVIATION)
    CREATE_PRIMITIVE_TYPE(GET_DISPLAY_DEPTH_LIMIT)
    CREATE_PRIMITIVE_TYPE(GET_DISPLAY_PANEL_TYPE)
    CREATE_PRIMITIVE_TYPE(GET_DOMAIN_PRIORITY)
    CREATE_PRIMITIVE_TYPE(GET_FAN_INFORMATION)
    CREATE_PRIMITIVE_TYPE(GET_FAN_PERFORMANCE_STATES)
    CREATE_PRIMITIVE_TYPE(GET_FAN_STATUS)
    CREATE_PRIMITIVE_TYPE(GET_GRAPHICS_CHIPSET_CHANNEL_TYPE)
    CREATE_PRIMITIVE_TYPE(GET_GRAPHICS_CHIPSET_SSC_ENABLED)
    CREATE_PRIMITIVE_TYPE(GET_LPM_TABLE)
    CREATE_PRIMITIVE_TYPE(GET_NOTIFICATION_TEMP_THRESHOLD)
    CREATE_PRIMITIVE_TYPE(GET_PARTICIPANT_LIST)
    CREATE_PRIMITIVE_TYPE(GET_PARTICIPANT_PERF_PRESENT_CAPABILITY)
    CREATE_PRIMITIVE_TYPE(GET_PARTICIPANT_SKU)
    CREATE_PRIMITIVE_TYPE(GET_PARTICIPANT_TYPE)
    CREATE_PRIMITIVE_TYPE(GET_PARTICIPANT_UTILIZATION)
    CREATE_PRIMITIVE_TYPE(GET_PERF_PSTATE_DEPTH_LIMIT)
    CREATE_PRIMITIVE_TYPE(GET_PERF_SUPPORT_STATES)
    CREATE_PRIMITIVE_TYPE(GET_POWER_THRESHOLD_COUNT)
    CREATE_PRIMITIVE_TYPE(GET_POWER_THRESHOLD_HYSTERESIS)
    CREATE_PRIMITIVE_TYPE(GET_POWER_THRESHOLDS)
    CREATE_PRIMITIVE_TYPE(GET_PROC_APPLICATION_EXCLUDE_LIST)
    CREATE_PRIMITIVE_TYPE(GET_PROC_CTDP_CAPABILITY)
    CREATE_PRIMITIVE_TYPE(GET_PROC_CTDP_CURRENT_SETTING)
    CREATE_PRIMITIVE_TYPE(GET_PROC_CTDP_LOCK_STATUS)
    CREATE_PRIMITIVE_TYPE(GET_PROC_CTDP_POINT_LIST)
    CREATE_PRIMITIVE_TYPE(GET_PROC_CTDP_SUPPORT_CHECK)
    CREATE_PRIMITIVE_TYPE(GET_PROC_CTDP_TAR_LOCK_STATUS)
    CREATE_PRIMITIVE_TYPE(GET_PROC_CURRENT_LOGICAL_PROCESSOR_OFFLINING)
    CREATE_PRIMITIVE_TYPE(GET_CURRENT_LOW_POWER_MODE)
    CREATE_PRIMITIVE_TYPE(GET_PROC_IO_THROTTLE_STATUS)
    CREATE_PRIMITIVE_TYPE(GET_PROC_LOGICAL_PROCESSOR_AFFINITY)
    CREATE_PRIMITIVE_TYPE(GET_PROC_LOGICAL_PROCESSOR_COUNT)
    CREATE_PRIMITIVE_TYPE(GET_PROC_MFM_LPM_SUPPORTED)
    CREATE_PRIMITIVE_TYPE(GET_PROC_MFM_MAX_EFFICIENCY_RATIO)
    CREATE_PRIMITIVE_TYPE(GET_PROC_MFM_MIN_SUPPORTED_RATIO)
    CREATE_PRIMITIVE_TYPE(GET_PROC_PERF_MAX_TIME)
    CREATE_PRIMITIVE_TYPE(GET_PROC_PERF_PRESENT_CAPABILITY)
    CREATE_PRIMITIVE_TYPE(GET_PROC_PERF_PSTATE_CURRENT_MAX_TODO)
    CREATE_PRIMITIVE_TYPE(GET_PROC_PERF_PSTATE_DEPTH_LIMIT)
    CREATE_PRIMITIVE_TYPE(GET_PROC_PERF_PSTATE_STATUS_TODO)
    CREATE_PRIMITIVE_TYPE(GET_PROC_PERF_SUPPORT_STATES)
    CREATE_PRIMITIVE_TYPE(GET_PROC_PERF_THROTTLE_CONTROL)
    CREATE_PRIMITIVE_TYPE(GET_PROC_PERF_THROTTLE_PRESENT_CAPABILITY)
    CREATE_PRIMITIVE_TYPE(GET_PROC_PERF_TSTATE_DEPTH_LIMIT)
    CREATE_PRIMITIVE_TYPE(GET_PROC_THERMAL_DESIGN_POWER)
    CREATE_PRIMITIVE_TYPE(GET_PROC_TJMAX)
    CREATE_PRIMITIVE_TYPE(GET_PROC_TURBO_ACTIVATION_RATIO)
    CREATE_PRIMITIVE_TYPE(GET_PROC_PROGRAMMABLE_POWER_LIMITS)
    CREATE_PRIMITIVE_TYPE(GET_PROC_TURBO_STATE)
    CREATE_PRIMITIVE_TYPE(GET_RAPL_DUTY_CYCLE)
    CREATE_PRIMITIVE_TYPE(GET_RAPL_ENERGY)
    CREATE_PRIMITIVE_TYPE(GET_RAPL_ENERGY_UNIT)
    CREATE_PRIMITIVE_TYPE(GET_RAPL_POWER)
    CREATE_PRIMITIVE_TYPE(GET_RAPL_POWER_CONTROL_CAPABILITIES)
    CREATE_PRIMITIVE_TYPE(GET_RAPL_POWER_DEFAULT)
    CREATE_PRIMITIVE_TYPE(GET_RAPL_POWER_LIMIT)
    CREATE_PRIMITIVE_TYPE(GET_RAPL_POWER_LIMIT_ENABLE)
    CREATE_PRIMITIVE_TYPE(GET_RAPL_POWER_LIMIT_LOCK)
    CREATE_PRIMITIVE_TYPE(GET_RAPL_POWER_MAX)
    CREATE_PRIMITIVE_TYPE(GET_RAPL_POWER_MAX_TIME_WINDOW)
    CREATE_PRIMITIVE_TYPE(GET_RAPL_POWER_MIN)
    CREATE_PRIMITIVE_TYPE(GET_RAPL_POWER_UNIT)
    CREATE_PRIMITIVE_TYPE(GET_RAPL_TIME_UNIT)
    CREATE_PRIMITIVE_TYPE(GET_RAPL_TIME_WINDOW)
    CREATE_PRIMITIVE_TYPE(GET_RFPROFILE_BIT_ERROR)
    CREATE_PRIMITIVE_TYPE(GET_RFPROFILE_CENTER_FREQUENCY)
    CREATE_PRIMITIVE_TYPE(GET_RFPROFILE_CHANNEL_NUMBER)
    CREATE_PRIMITIVE_TYPE(GET_RFPROFILE_CLIP_PERCENT_LEFT)
    CREATE_PRIMITIVE_TYPE(GET_RFPROFILE_CLIP_PERCENT_RIGHT)
    CREATE_PRIMITIVE_TYPE(GET_RFPROFILE_CONNECTION_STATUS)
    CREATE_PRIMITIVE_TYPE(GET_RFPROFILE_DEFAULT_CENTER_FREQUENCY)
    CREATE_PRIMITIVE_TYPE(GET_RFPROFILE_FREQUENCY_SPREAD_LEFT)
    CREATE_PRIMITIVE_TYPE(GET_RFPROFILE_FREQUENCY_SPREAD_RIGHT)
    CREATE_PRIMITIVE_TYPE(GET_RFPROFILE_FREQUENCY_ADJUST_RESOLUTION)
    CREATE_PRIMITIVE_TYPE(GET_RFPROFILE_NOISE_POWER)
    CREATE_PRIMITIVE_TYPE(GET_RFPROFILE_NOTCH_LEFT)
    CREATE_PRIMITIVE_TYPE(GET_RFPROFILE_NOTCH_RIGHT)
    CREATE_PRIMITIVE_TYPE(GET_RFPROFILE_RSSI)
    CREATE_PRIMITIVE_TYPE(GET_RFPROFILE_SHAPE_LEFT)
    CREATE_PRIMITIVE_TYPE(GET_RFPROFILE_SHAPE_RIGHT)
    CREATE_PRIMITIVE_TYPE(GET_RFPROFILE_SIGNAL_TO_NOISE_RATIO)
    CREATE_PRIMITIVE_TYPE(GET_SUPPORTED_POLICIES)
    CREATE_PRIMITIVE_TYPE(GET_TEMPERATURE)
    CREATE_PRIMITIVE_TYPE(GET_TEMPERATURE_APPROX_TABLE)
    CREATE_PRIMITIVE_TYPE(GET_TEMPERATURE_THRESHOLD_COUNT)
    CREATE_PRIMITIVE_TYPE(GET_TEMPERATURE_THRESHOLD_HYSTERESIS)
    CREATE_PRIMITIVE_TYPE(GET_TEMPERATURE_THRESHOLDS)
    CREATE_PRIMITIVE_TYPE(GET_THERMAL_RELATIONSHIP_TABLE)
    CREATE_PRIMITIVE_TYPE(GET_TRIP_POINT_ACTIVE)
    CREATE_PRIMITIVE_TYPE(GET_TRIP_POINT_CRITICAL)
    CREATE_PRIMITIVE_TYPE(GET_TRIP_POINT_HOT)
    CREATE_PRIMITIVE_TYPE(GET_TRIP_POINT_PASSIVE)
    CREATE_PRIMITIVE_TYPE(GET_TRIP_POINT_WARM)
    CREATE_PRIMITIVE_TYPE(GET_TSTATE_CURRENT)
    CREATE_PRIMITIVE_TYPE(GET_TSTATES)
    CREATE_PRIMITIVE_TYPE(SET_ACTIVE_CORE_LIMIT)
    CREATE_PRIMITIVE_TYPE(SET_ACTIVE_RELATIONSHIP_TABLE)
    CREATE_PRIMITIVE_TYPE(SET_AMBIENT_TEMPERATURE_INDICATION)
    CREATE_PRIMITIVE_TYPE(SET_CLOCK_SSC_DISABLED)
    CREATE_PRIMITIVE_TYPE(SET_CLOCK_SSC_ENABLED)
    CREATE_PRIMITIVE_TYPE(SET_COOLING_POLICY)
    CREATE_PRIMITIVE_TYPE(SET_CTDP_POINT)
    CREATE_PRIMITIVE_TYPE(SET_CURRENT_LOW_POWER_MODE)
    CREATE_PRIMITIVE_TYPE(SET_DEVICE_TEMPERATURE_INDICATION)
    CREATE_PRIMITIVE_TYPE(SET_DISPLAY_BRIGHTNESS_HARD)
    CREATE_PRIMITIVE_TYPE(SET_DISPLAY_BRIGHTNESS_SOFT)
    CREATE_PRIMITIVE_TYPE(SET_DSP)
    CREATE_PRIMITIVE_TYPE(SET_FAN_LEVEL)
    CREATE_PRIMITIVE_TYPE(SET_LPM_TABLE)
    CREATE_PRIMITIVE_TYPE(SET_OPERATING_SYSTEM_CAPABILITIES)
    CREATE_PRIMITIVE_TYPE(SET_PERF_PRESENT_CAPABILITY)
    CREATE_PRIMITIVE_TYPE(SET_PERF_SUPPORT_STATE)
    CREATE_PRIMITIVE_TYPE(SET_POWER_THRESHOLD_HYSTERESIS)
    CREATE_PRIMITIVE_TYPE(SET_POWER_THRESHOLDS)
    CREATE_PRIMITIVE_TYPE(SET_PROC_CTDP_CONTROL)
    CREATE_PRIMITIVE_TYPE(SET_RFPROFILE_CENTER_FREQUENCY)
    CREATE_PRIMITIVE_TYPE(SET_PROC_IO_THROTTLE_CONTROL)
    CREATE_PRIMITIVE_TYPE(SET_PROC_LOGICAL_PROCESSOR_AFFINITY)
    CREATE_PRIMITIVE_TYPE(SET_PROC_TURBO_ACTIVATION_RATIO)
    CREATE_PRIMITIVE_TYPE(SET_PROC_TURBO_STATE)
    CREATE_PRIMITIVE_TYPE(SET_RAPL_POWER_LIMIT)
    CREATE_PRIMITIVE_TYPE(SET_RAPL_POWER_LIMIT_ENABLE)
    CREATE_PRIMITIVE_TYPE(SET_RAPL_TIME_WINDOW)
    CREATE_PRIMITIVE_TYPE(SET_SYSTEM_HIBERNATE)
    CREATE_PRIMITIVE_TYPE(SET_SYSTEM_SHUTDOWN)
    CREATE_PRIMITIVE_TYPE(SET_SYSTEM_SLEEP)
    CREATE_PRIMITIVE_TYPE(SET_TEMPERATURE)
    CREATE_PRIMITIVE_TYPE(SET_TEMPERATURE_THRESHOLD_HYSTERESIS)
    CREATE_PRIMITIVE_TYPE(SET_TEMPERATURE_THRESHOLDS)
    CREATE_PRIMITIVE_TYPE(SET_THERMAL_RELATIONSHIP_TABLE)
    CREATE_PRIMITIVE_TYPE(SET_TRIP_POINT_ACTIVE)
    CREATE_PRIMITIVE_TYPE(SET_TRIP_POINT_CRITICAL)
    CREATE_PRIMITIVE_TYPE(SET_TRIP_POINT_HOT)
    CREATE_PRIMITIVE_TYPE(SET_TRIP_POINT_PASSIVE)
    CREATE_PRIMITIVE_TYPE(SET_TRIP_POINT_WARM)
    CREATE_PRIMITIVE_TYPE(SET_TSTATE_CURRENT)
#else
    ENUM_ESIF_PRIMITIVE_TYPE(CREATE_PRIMITIVE_TYPE)
#endif
    }
    return str;
}

#endif /* _ESIF_PRIMITIVE_TYPE_H_ */